/* TEKNISA

Nome: 7605_PMESTPS_EXPORTA_CARDAPIOPME.SQL

Descrio:


Criao:
20/02/2006 - Rafael Christopher de Souza e Silva

*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'EXPORTA_CARDAPIOPME' AND
	        TYPE = 'P' 			         AND
	        U.UID = O.UID             	AND
	        U.NAME = USER)
DROP PROCEDURE EXPORTA_CARDAPIOPME;
GO

CREATE PROCEDURE EXPORTA_CARDAPIOPME @P_CDFILIORIG  VARCHAR(4),
                                     @P_CDSERVORIG  VARCHAR(2000),
                                     @P_CDTIPOCARD  VARCHAR(10),
                                     @P_NRCARDORIG  VARCHAR(20),
                                     @P_NRCARDDEST  VARCHAR(20),
                                     @P_DTINIORIG   DATETIME,
                                     @P_DTFINORIG   DATETIME,
                                     @P_CDFILIDEST  VARCHAR(4),
                                     @P_CDSERVDEST  VARCHAR(2000),
                                     @P_DTINIDEST   DATETIME,
                                     @P_DTFINDEST   DATETIME,
                                     @P_CONFIGORIG  VARCHAR(2000) OUTPUT
AS
   DECLARE @V_DTMESORIG        DATETIME;
   DECLARE @V_DTMESDEST        DATETIME;
   DECLARE @V_DTCARDDEST       DATETIME;
   DECLARE @V_CONTCARDDEST     NUMERIC;
   DECLARE @V_NRCARDIAPME      VARCHAR(20);
   DECLARE @V_NRCARDIAPMECENT  VARCHAR(20);
   DECLARE @V_MAXNRSEQDEST     NUMERIC;
   DECLARE @V_MAXNRORDDEST     NUMERIC;
   DECLARE @V_CONTPRAT         NUMERIC;
   DECLARE @V_CDFILAUXDEST     VARCHAR(4);
   DECLARE @V_IDCARDIAUTIL     VARCHAR(1);
   DECLARE @V_DIASEMANA        NUMERIC;
   DECLARE @V_CONTFERIFILI     NUMERIC;
   DECLARE @V_CONTFERICARD     NUMERIC;   
   DECLARE @V_CONTPRODRECE     NUMERIC;
   DECLARE @V_IDUTRPADCA       VARCHAR(1);
   DECLARE @V_NOVOSEQ          NUMERIC;
   DECLARE @V_NOVOORD          NUMERIC;
   DECLARE @V_COUNTCARDIAPME   NUMERIC;
   DECLARE @V_EXISTE_CARDIAPME NUMERIC;
   DECLARE @V_CDCONTADOR       VARCHAR(50);

    /* Variveis para cursores */

   DECLARE @C_DATAS_DTORIGEM        DATETIME;
   DECLARE @C_COMENSSERV_QTCOM_CENT DOUBLE PRECISION;
   DECLARE @C_COMENSSERV_QTCOM      DOUBLE PRECISION;
   DECLARE @C_COMENSSERV_QTCLI      DOUBLE PRECISION;
   DECLARE @C_COMENSSERV_QTFUN      DOUBLE PRECISION;
   DECLARE @C_COMENSSERV_QTDOA      DOUBLE PRECISION;

   DECLARE @C_INS_CONFIG_CDFILIDEST   VARCHAR(4);
   DECLARE @C_INS_CONFIG_NRCARDDEST   VARCHAR(10);
   DECLARE @C_INS_CONFIG_CDSERVDEST   VARCHAR(5);
   DECLARE @C_INS_CONFIG_CDTIPOPRAT   VARCHAR(2);
   DECLARE @C_INS_CONFIG_IDOPCCNFCPME VARCHAR(1);
   DECLARE @C_INS_CONFIG_IDIMPCNFCPME VARCHAR(1);

   DECLARE @V_ORD_SEQ NUMERIC;
   DECLARE @V_ORD_ORD NUMERIC;   

   DECLARE @C_CARD_CDFILCENTPME       VARCHAR(4);
   DECLARE @C_CARD_CDSERVFILI         VARCHAR(5);
   DECLARE @C_CARD_DTCARDIAPME        DATETIME;
   DECLARE @C_CARD_NRCARDIAPME        VARCHAR(20);
   DECLARE @C_CARD_NRCARDPME          VARCHAR(10);
   DECLARE @C_CARD_QTCOMESTCPME       DOUBLE PRECISION;
   DECLARE @C_CARD_QTCLIESTCPME       DOUBLE PRECISION;
   DECLARE @C_CARD_QTFUNESTCPME       DOUBLE PRECISION;
   DECLARE @C_CARD_QTDOAESTCPME       DOUBLE PRECISION;

   DECLARE @C_CARDAGREG_CDFILIAL      VARCHAR(2000);

   DECLARE @C_PRATOS_CDFILIAL         VARCHAR(4);
   DECLARE @C_PRATOS_NRCARDPME        VARCHAR(10);
   DECLARE @C_PRATOS_NRSEQPRATCAR     NUMERIC;
   DECLARE @C_PRATOS_CDFILAUXPRAT     VARCHAR(4);
   DECLARE @C_PRATOS_CDPRATO          VARCHAR(10);
   DECLARE @C_PRATOS_VRPECONSCPME     DOUBLE PRECISION;
   DECLARE @C_PRATOS_CDTIPOPRAT       VARCHAR(2);
   DECLARE @C_PRATOS_NRORDPRATCAR     NUMERIC;
   DECLARE @C_PRATOS_NMPRATO          VARCHAR(40);

BEGIN
   SET @V_DTMESORIG = @P_DTINIORIG;
   SET @V_DTMESDEST = @P_DTINIDEST;

   SET @V_MAXNRSEQDEST = 0;
   SET @V_MAXNRORDDEST = 0;

   /*Busca a ltima configurao do cardpio de destino */
   SELECT
      @V_MAXNRSEQDEST = ISNULL(MAX(NRSEQCNFCPME),0),
      @V_MAXNRORDDEST = ISNULL(MAX(NRORDCNFCPME),0)
   FROM
      CONFCARDPME
   WHERE
      (CDFILCENTPME = @P_CDFILIDEST ) AND
      (CDSERVFILI   = @P_CDSERVDEST ) AND
      (NRCARDPME    = @P_NRCARDDEST );

   DECLARE C_INS_CONFIG CURSOR FOR
      SELECT
         @P_CDFILIDEST CDFILIDEST, @P_NRCARDDEST NRCARDDEST,
         @P_CDSERVDEST CDSERVDEST, CDTIPOPRAT, IDOPCCNFCPME, IDIMPCNFCPME
      FROM
         CONFCARDPME
      WHERE
         (CDFILCENTPME = @P_CDFILIORIG) AND
         (CDSERVFILI   = @P_CDSERVORIG) AND
         (NRCARDPME    = @P_NRCARDORIG) AND
         (CHARINDEX(RIGHT(REPLICATE('0', 3) + CONVERT(VARCHAR, NRSEQCNFCPME), 3), @P_CONFIGORIG) <> 0)
      ORDER BY
         NRORDCNFCPME;

   OPEN C_INS_CONFIG;
   FETCH NEXT FROM C_INS_CONFIG INTO @C_INS_CONFIG_CDFILIDEST,
                                     @C_INS_CONFIG_NRCARDDEST,
                                     @C_INS_CONFIG_CDSERVDEST,
                                     @C_INS_CONFIG_CDTIPOPRAT,
                                     @C_INS_CONFIG_IDOPCCNFCPME,
                                     @C_INS_CONFIG_IDIMPCNFCPME;

   SET @V_ORD_SEQ = @V_MAXNRSEQDEST + 1;
   SET @V_ORD_ORD = @V_MAXNRORDDEST + 1;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      INSERT INTO CONFCARDPME
         (CDFILCENTPME, NRCARDPME, CDSERVFILI, NRSEQCNFCPME,
          CDTIPOPRAT, IDOPCCNFCPME, IDIMPCNFCPME, NRORDCNFCPME)
      VALUES
         (@C_INS_CONFIG_CDFILIDEST,
          @C_INS_CONFIG_NRCARDDEST,
          @C_INS_CONFIG_CDSERVDEST,
          @V_ORD_SEQ,
          @C_INS_CONFIG_CDTIPOPRAT,
          @C_INS_CONFIG_IDOPCCNFCPME,
          @C_INS_CONFIG_IDIMPCNFCPME,
          @V_ORD_ORD);

      SET @V_ORD_SEQ = @V_ORD_SEQ + 1;
      SET @V_ORD_ORD = @V_ORD_ORD + 1;

      FETCH NEXT FROM C_INS_CONFIG INTO @C_INS_CONFIG_CDFILIDEST,
                                        @C_INS_CONFIG_NRCARDDEST,
                                        @C_INS_CONFIG_CDSERVDEST,
                                        @C_INS_CONFIG_CDTIPOPRAT,
                                        @C_INS_CONFIG_IDOPCCNFCPME,
                                        @C_INS_CONFIG_IDIMPCNFCPME;
   END;
   CLOSE C_INS_CONFIG;
   DEALLOCATE C_INS_CONFIG;

   SET @V_DTCARDDEST = @P_DTINIDEST;

   /* Verifica o parmetro que permite cardpio em dia no-til */
   SELECT
      @V_IDCARDIAUTIL = ISNULL(MAX(IDCARDIAUTIL), 'N')
   FROM
      PARAMPLANEJA
   WHERE
      CDFILIAL = @P_CDFILIDEST;

   DECLARE C_DATAS CURSOR FOR
      SELECT
         DTDATA
      FROM
         DATA
      WHERE
         DTDATA BETWEEN @P_DTINIORIG AND @P_DTFINORIG
      ORDER BY
         DTDATA;

   OPEN C_DATAS;
   FETCH NEXT FROM C_DATAS INTO @C_DATAS_DTORIGEM;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      SELECT
         @V_CONTFERIFILI = COUNT(*)
      FROM
         FERIFILI
      WHERE
         (CDFILIAL   = @P_CDFILIDEST) AND
         (DTFERIFILI = @V_DTCARDDEST);

      SELECT
         @V_CONTFERICARD = COUNT(*)
      FROM
         FERICARD
      WHERE
         (CDFILIAL   = @P_CDFILIDEST) AND
         (DTFERICARD = @V_DTCARDDEST);

      /* Grava o nmero correspondente ao dia da semana */
      IF @V_CONTFERICARD = 0 BEGIN
         SET @V_DIASEMANA = DATEPART(dw,@V_DTCARDDEST);
      END
      ELSE BEGIN
         SET @V_DIASEMANA = 8;
      END;

      /* Permite incluso quando: */
      /* V_IDCARDIAUTIL <> 'S' (NO BLOQUEIA INCLUSO EM DIA NO TIL) OR
         V_IDCARDIAUTIL = 'S' AND V_CONTFERIFILI = 0 (SE BLOQUEIA, O DIA  NORMAL) */
      IF (@V_DTCARDDEST <= @P_DTFINDEST) AND
         ((@V_IDCARDIAUTIL <> 'S') OR ((@V_IDCARDIAUTIL = 'S') AND (@V_CONTFERIFILI = 0))) BEGIN
         DECLARE C_CARDORIG CURSOR FOR
            SELECT
                CDFILCENTPME,
                CDSERVFILI,
                DTCARDIAPME,
                NRCARDIAPME,
                NRCARDPME,
                QTCOMESTCPME,
                QTCLIESTCPME,
                QTFUNESTCPME,
                QTDOAESTCPME
            FROM
                CARDIAPME
            WHERE
                (CDFILCENTPME = @P_CDFILIORIG     ) AND
                (NRCARDPME    = @P_NRCARDORIG     ) AND
                (CDSERVFILI   = @P_CDSERVORIG     ) AND
                (DTCARDIAPME  = @C_DATAS_DTORIGEM ) AND
                (CDFILCENTPME = CDFILIAL          )
            ORDER BY
                CDFILCENTPME,
                CDSERVFILI,
                NRCARDPME;

         OPEN C_CARDORIG;
         FETCH NEXT FROM C_CARDORIG INTO @C_CARD_CDFILCENTPME,
                                         @C_CARD_CDSERVFILI,
                                         @C_CARD_DTCARDIAPME,
                                         @C_CARD_NRCARDIAPME,
                                         @C_CARD_NRCARDPME,
                                         @C_CARD_QTCOMESTCPME,
                                         @C_CARD_QTCLIESTCPME,
                                         @C_CARD_QTFUNESTCPME,
                                         @C_CARD_QTDOAESTCPME;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            SELECT
               @V_CONTCARDDEST = COUNT(*)
            FROM
               CARDIAPME
            WHERE
               (CDFILCENTPME = @P_CDFILIDEST ) AND
               (NRCARDPME    = @P_NRCARDDEST ) AND
               (CDSERVFILI   = @P_CDSERVDEST ) AND
               (DTCARDIAPME  = @V_DTCARDDEST ) AND
               (CDFILCENTPME = CDFILIAL      );

            /* Gera novo nmero de cardpio se no existir */
            IF @V_CONTCARDDEST = 0 BEGIN
               /* Insere o cardpio para a Central de Merenda */
               SET @V_NRCARDIAPMECENT = NULL;
               SET @V_CDCONTADOR = 'CARDIAPME' + @P_CDFILIDEST  + @P_NRCARDDEST;
               EXEC NOVO_CODIGO @V_CDCONTADOR, @V_NRCARDIAPMECENT OUTPUT, 1;
               SET @V_NRCARDIAPMECENT = SUBSTRING(@V_NRCARDIAPMECENT,11,10);

               DECLARE C_COMENSSERV CURSOR FOR
                  SELECT
                     ISNULL(CASE @V_DIASEMANA
                               WHEN 2 THEN A.QTCOMPMESEG
                               WHEN 3 THEN A.QTCOMPMETER
                               WHEN 4 THEN A.QTCOMPMEQUA
                               WHEN 5 THEN A.QTCOMPMEQUI
                               WHEN 6 THEN A.QTCOMPMESEX
                               WHEN 7 THEN A.QTCOMPMESAB
                               WHEN 1 THEN A.QTCOMPMEDOM
                               WHEN 8 THEN A.QTCOMPMEFER
                            END, 0),
                     ISNULL(CASE @V_DIASEMANA
                               WHEN 2 THEN A.QTCLIPMESEG
                               WHEN 3 THEN A.QTCLIPMETER
                               WHEN 4 THEN A.QTCLIPMEQUA
                               WHEN 5 THEN A.QTCLIPMEQUI
                               WHEN 6 THEN A.QTCLIPMESEX
                               WHEN 7 THEN A.QTCLIPMESAB
                               WHEN 1 THEN A.QTCLIPMEDOM
                               WHEN 8 THEN A.QTCLIPMEFER
                            END,0),
                     ISNULL(CASE @V_DIASEMANA
                               WHEN 2 THEN A.QTFUNPMESEG
                               WHEN 3 THEN A.QTFUNPMETER
                               WHEN 4 THEN A.QTFUNPMEQUA
                               WHEN 5 THEN A.QTFUNPMEQUI
                               WHEN 6 THEN A.QTFUNPMESEX
                               WHEN 7 THEN A.QTFUNPMESAB
                               WHEN 1 THEN A.QTFUNPMEDOM
                               WHEN 8 THEN A.QTFUNPMEFER
                            END,0),
                     ISNULL(CASE @V_DIASEMANA
                               WHEN 2 THEN A.QTDOAPMESEG
                               WHEN 3 THEN A.QTDOAPMETER
                               WHEN 4 THEN A.QTDOAPMEQUA
                               WHEN 5 THEN A.QTDOAPMEQUI
                               WHEN 6 THEN A.QTDOAPMESEX
                               WHEN 7 THEN A.QTDOAPMESAB
                               WHEN 1 THEN A.QTDOAPMEDOM
                               WHEN 8 THEN A.QTDOAPMEFER
                            END,0)
                  FROM (SELECT
                           SUM(QTCOMPMESEG) AS QTCOMPMESEG, SUM(QTCOMPMETER) AS QTCOMPMETER, SUM(QTCOMPMEQUA) AS QTCOMPMEQUA, SUM(QTCOMPMEQUI) AS QTCOMPMEQUI, SUM(QTCOMPMESEX) AS QTCOMPMESEX, SUM(QTCOMPMESAB) AS QTCOMPMESAB, SUM(QTCOMPMEDOM) AS QTCOMPMEDOM, SUM(QTCOMPMEFER) AS QTCOMPMEFER,
                           SUM(QTCLIPMESEG) AS QTCLIPMESEG, SUM(QTCLIPMETER) AS QTCLIPMETER, SUM(QTCLIPMEQUA) AS QTCLIPMEQUA, SUM(QTCLIPMEQUI) AS QTCLIPMEQUI, SUM(QTCLIPMESEX) AS QTCLIPMESEX, SUM(QTCLIPMESAB) AS QTCLIPMESAB, SUM(QTCLIPMEDOM) AS QTCLIPMEDOM, SUM(QTCLIPMEFER) AS QTCLIPMEFER,
                           SUM(QTFUNPMESEG) AS QTFUNPMESEG, SUM(QTFUNPMETER) AS QTFUNPMETER, SUM(QTFUNPMEQUA) AS QTFUNPMEQUA, SUM(QTFUNPMEQUI) AS QTFUNPMEQUI, SUM(QTFUNPMESEX) AS QTFUNPMESEX, SUM(QTFUNPMESAB) AS QTFUNPMESAB, SUM(QTFUNPMEDOM) AS QTFUNPMEDOM, SUM(QTFUNPMEFER) AS QTFUNPMEFER,
                           SUM(QTDOAPMESEG) AS QTDOAPMESEG, SUM(QTDOAPMETER) AS QTDOAPMETER, SUM(QTDOAPMEQUA) AS QTDOAPMEQUA, SUM(QTDOAPMEQUI) AS QTDOAPMEQUI, SUM(QTDOAPMESEX) AS QTDOAPMESEX, SUM(QTDOAPMESAB) AS QTDOAPMESAB, SUM(QTDOAPMEDOM) AS QTDOAPMEDOM, SUM(QTDOAPMEFER) AS QTDOAPMEFER
                        FROM
                           COMESERVTCAR C,
                           FILITIPOCARD F
                        WHERE
                           (C.CDFILCENTPME = @P_CDFILIDEST ) AND
                           (C.CDTIPOCARD   = @P_CDTIPOCARD ) AND
                           (C.CDSERVFILI   = @P_CDSERVDEST ) AND
                           (F.CDFILCENTPME = C.CDFILCENTPME) AND
                           (F.CDTIPOCARD   = C.CDTIPOCARD  ) AND
                           (F.CDFILIAL     = C.CDFILIAL    ) AND
                           (F.IDTCARATFILI = 'S'           ) AND
                           EXISTS (SELECT 1 FROM FILIAL FI WHERE FI.CDFILIAL = C.CDFILIAL AND FI.CDFILCENTPME = C.CDFILCENTPME)
                       ) A;
               OPEN C_COMENSSERV;
               FETCH NEXT FROM C_COMENSSERV INTO @C_COMENSSERV_QTCOM_CENT,
                                                 @C_COMENSSERV_QTCLI,
                                                 @C_COMENSSERV_QTFUN,
                                                 @C_COMENSSERV_QTDOA;
               IF (@@FETCH_STATUS <> 0) BEGIN
                  SET @C_COMENSSERV_QTCOM_CENT = 0;
                  SET @C_COMENSSERV_QTCLI = 0;
                  SET @C_COMENSSERV_QTFUN = 0;
                  SET @C_COMENSSERV_QTDOA = 0;
               END;
               CLOSE C_COMENSSERV;
               DEALLOCATE C_COMENSSERV;

               IF (@C_COMENSSERV_QTCOM_CENT <> 0) AND (NOT (@C_COMENSSERV_QTCOM_CENT IS NULL)) BEGIN
                  SELECT
                     @V_EXISTE_CARDIAPME = COUNT(*)
                  FROM
                     CARDIAPME
                  WHERE
                     (CDFILCENTPME = @P_CDFILIDEST ) AND
                     (NRCARDPME    = @P_NRCARDDEST ) AND
                     (CDSERVFILI   = @P_CDSERVDEST ) AND
                     (DTCARDIAPME  = @V_DTCARDDEST ) AND
                     (CDFILIAL     = @P_CDFILIDEST ) ;

                  IF @V_EXISTE_CARDIAPME = 0 BEGIN
                     INSERT INTO CARDIAPME
                       (CDFILCENTPME, NRCARDPME, NRCARDIAPME, CDSERVFILI, CDFILIAL,
                        DTCARDIAPME, QTCOMESTCPME, QTCLIESTCPME, QTFUNESTCPME, QTDOAESTCPME,
                        QTCOMEFECPME, QTCLIEFECPME, QTFUNEFECPME, QTDOAEFECPME, IDCARDESPEC)
                     VALUES
                        (@P_CDFILIDEST, @P_NRCARDDEST, @V_NRCARDIAPMECENT, @P_CDSERVDEST, @P_CDFILIDEST,
                         @V_DTCARDDEST, @C_COMENSSERV_QTCOM_CENT, @C_COMENSSERV_QTCLI, @C_COMENSSERV_QTFUN,
                         @C_COMENSSERV_QTDOA, 0, 0, 0, 0, 'N');
                  END;
               END;

               /* Loop para inserir os cardpios para as Agregadas */
               DECLARE C_CARDFILIAGREG CURSOR FOR
                  SELECT
                     T.CDFILIAL
                  FROM
                     FILITIPOCARD T,
                     SERVTIPOCARD S
                  WHERE
                     (T.CDFILCENTPME = @P_CDFILIDEST  ) AND
                     (T.CDTIPOCARD   = @P_CDTIPOCARD  ) AND
                     (S.CDFILCENTPME = T.CDFILCENTPME ) AND
                     (S.CDTIPOCARD   = T.CDTIPOCARD   ) AND
                     (S.CDSERVFILI   = @P_CDSERVDEST  ) AND
                     (T.IDTCARATFILI = 'S'            ) AND
                     EXISTS (SELECT 1 FROM FILIAL FI WHERE FI.CDFILIAL = T.CDFILIAL AND FI.CDFILCENTPME = T.CDFILCENTPME);

               OPEN C_CARDFILIAGREG;
               FETCH NEXT FROM C_CARDFILIAGREG INTO @C_CARDAGREG_CDFILIAL;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SELECT
                     @V_COUNTCARDIAPME = COUNT(*)
                  FROM
                     CARDIAPME
                  WHERE
                     (CDFILCENTPME = @P_CDFILIDEST        ) AND
                     (NRCARDPME    = @P_NRCARDDEST        ) AND
                     (CDSERVFILI   = @P_CDSERVDEST        ) AND
                     (CDFILIAL     = @C_CARDAGREG_CDFILIAL) AND
                     (DTCARDIAPME  = @V_DTCARDDEST        );

                  IF @V_COUNTCARDIAPME = 0 BEGIN
                     /* Inclui o cardpio somente se a agregada utilizar o tipo de cardpio */
                     /* Gera o novo cdigo */
                     SET @V_NRCARDIAPME = NULL;
                     SET @V_CDCONTADOR = 'CARDIAPME' + @P_CDFILIDEST + @P_NRCARDDEST;
                     EXEC NOVO_CODIGO @V_CDCONTADOR, @V_NRCARDIAPME OUTPUT, 1;
                     SET @V_NRCARDIAPME = SUBSTRING(@V_NRCARDIAPME,11,10);
                     /* Total de comensais por servio da agregada */
                     DECLARE C_COMENSSERV_AGREG CURSOR FOR
                        SELECT
                            ISNULL(CASE @V_DIASEMANA
                                      WHEN 2 THEN A.QTCOMPMESEG
                                      WHEN 3 THEN A.QTCOMPMETER
                                      WHEN 4 THEN A.QTCOMPMEQUA
                                      WHEN 5 THEN A.QTCOMPMEQUI
                                      WHEN 6 THEN A.QTCOMPMESEX
                                      WHEN 7 THEN A.QTCOMPMESAB
                                      WHEN 1 THEN A.QTCOMPMEDOM
                                      WHEN 8 THEN A.QTCOMPMEFER
                                   END,0),
                           ISNULL(CASE @V_DIASEMANA
                                     WHEN 2 THEN A.QTCLIPMESEG
                                     WHEN 3 THEN A.QTCLIPMETER
                                     WHEN 4 THEN A.QTCLIPMEQUA
                                     WHEN 5 THEN A.QTCLIPMEQUI
                                     WHEN 6 THEN A.QTCLIPMESEX
                                     WHEN 7 THEN A.QTCLIPMESAB
                                     WHEN 1 THEN A.QTCLIPMEDOM
                                     WHEN 8 THEN A.QTCLIPMEFER
                                  END,0),
                            ISNULL(CASE @V_DIASEMANA
                                      WHEN 2 THEN A.QTFUNPMESEG
                                      WHEN 3 THEN A.QTFUNPMETER
                                      WHEN 4 THEN A.QTFUNPMEQUA
                                      WHEN 5 THEN A.QTFUNPMEQUI
                                      WHEN 6 THEN A.QTFUNPMESEX
                                      WHEN 7 THEN A.QTFUNPMESAB
                                      WHEN 1 THEN A.QTFUNPMEDOM
                                      WHEN 8 THEN A.QTFUNPMEFER
                                   END,0),
                            ISNULL(CASE @V_DIASEMANA
                                      WHEN 2 THEN A.QTDOAPMESEG
                                      WHEN 3 THEN A.QTDOAPMETER
                                      WHEN 4 THEN A.QTDOAPMEQUA
                                      WHEN 5 THEN A.QTDOAPMEQUI
                                      WHEN 6 THEN A.QTDOAPMESEX
                                      WHEN 7 THEN A.QTDOAPMESAB
                                      WHEN 1 THEN A.QTDOAPMEDOM
                                      WHEN 8 THEN A.QTDOAPMEFER
                                   END,0)
                        FROM (
                        SELECT SUM(QTCOMPMESEG) AS QTCOMPMESEG, SUM(QTCOMPMETER) AS QTCOMPMETER, SUM(QTCOMPMEQUA) AS QTCOMPMEQUA, SUM(QTCOMPMEQUI) AS QTCOMPMEQUI, SUM(QTCOMPMESEX) AS QTCOMPMESEX, SUM(QTCOMPMESAB) AS QTCOMPMESAB, SUM(QTCOMPMEDOM) AS QTCOMPMEDOM, SUM(QTCOMPMEFER) AS QTCOMPMEFER,
                               SUM(QTCLIPMESEG) AS QTCLIPMESEG, SUM(QTCLIPMETER) AS QTCLIPMETER, SUM(QTCLIPMEQUA) AS QTCLIPMEQUA, SUM(QTCLIPMEQUI) AS QTCLIPMEQUI, SUM(QTCLIPMESEX) AS QTCLIPMESEX, SUM(QTCLIPMESAB) AS QTCLIPMESAB, SUM(QTCLIPMEDOM) AS QTCLIPMEDOM, SUM(QTCLIPMEFER) AS QTCLIPMEFER,
                               SUM(QTFUNPMESEG) AS QTFUNPMESEG, SUM(QTFUNPMETER) AS QTFUNPMETER, SUM(QTFUNPMEQUA) AS QTFUNPMEQUA, SUM(QTFUNPMEQUI) AS QTFUNPMEQUI, SUM(QTFUNPMESEX) AS QTFUNPMESEX, SUM(QTFUNPMESAB) AS QTFUNPMESAB, SUM(QTFUNPMEDOM) AS QTFUNPMEDOM, SUM(QTFUNPMEFER) AS QTFUNPMEFER,
                               SUM(QTDOAPMESEG) AS QTDOAPMESEG, SUM(QTDOAPMETER) AS QTDOAPMETER, SUM(QTDOAPMEQUA) AS QTDOAPMEQUA, SUM(QTDOAPMEQUI) AS QTDOAPMEQUI, SUM(QTDOAPMESEX) AS QTDOAPMESEX, SUM(QTDOAPMESAB) AS QTDOAPMESAB, SUM(QTDOAPMEDOM) AS QTDOAPMEDOM, SUM(QTDOAPMEFER) AS QTDOAPMEFER
                        FROM
                           COMESERVTCAR C,
                           FILITIPOCARD F
                        WHERE
                           (C.CDFILCENTPME = @P_CDFILIDEST        ) AND
                           (C.CDTIPOCARD   = @P_CDTIPOCARD        ) AND
                           (C.CDSERVFILI   = @P_CDSERVDEST        ) AND
                           (C.CDFILIAL     = @C_CARDAGREG_CDFILIAL) AND
                           (F.CDFILCENTPME = C.CDFILCENTPME       ) AND
                           (F.CDTIPOCARD   = C.CDTIPOCARD         ) AND
                           (F.CDFILIAL     = C.CDFILIAL           ) AND
                           (F.IDTCARATFILI = 'S'                  )) A;

                     OPEN C_COMENSSERV_AGREG;
                     FETCH NEXT FROM C_COMENSSERV_AGREG INTO @C_COMENSSERV_QTCOM,
                                                             @C_COMENSSERV_QTCLI,
                                                             @C_COMENSSERV_QTFUN,
                                                             @C_COMENSSERV_QTDOA;
                     IF (@@FETCH_STATUS <> 0) BEGIN
                        SET @C_COMENSSERV_QTCOM = 0;
                        SET @C_COMENSSERV_QTCLI = 0;
                        SET @C_COMENSSERV_QTFUN = 0;
                        SET @C_COMENSSERV_QTDOA = 0;
                     END;
                     CLOSE C_COMENSSERV_AGREG;
                     DEALLOCATE C_COMENSSERV_AGREG;

                     /*Insere na Cardiapme para cada Filial Agregada*/
                     SELECT
                        @V_EXISTE_CARDIAPME = COUNT(*)
                     FROM
                        CARDIAPME
                     WHERE
                        (CDFILCENTPME = @P_CDFILIDEST        ) AND
                        (NRCARDPME    = @P_NRCARDDEST        ) AND
                        (CDSERVFILI   = @P_CDSERVDEST        ) AND
                        (DTCARDIAPME  = @V_DTCARDDEST        ) AND
                        (CDFILIAL     = @C_CARDAGREG_CDFILIAL);

                     IF @V_EXISTE_CARDIAPME = 0 BEGIN
                        INSERT INTO CARDIAPME
                          (CDFILCENTPME, NRCARDPME, NRCARDIAPME, CDSERVFILI, CDFILIAL,
                           DTCARDIAPME, QTCOMESTCPME, QTCLIESTCPME, QTFUNESTCPME, QTDOAESTCPME,
                           QTCOMEFECPME, QTCLIEFECPME, QTFUNEFECPME, QTDOAEFECPME, IDCARDESPEC)
                        VALUES
                           (@P_CDFILIDEST, @P_NRCARDDEST, @V_NRCARDIAPME, @P_CDSERVDEST, @C_CARDAGREG_CDFILIAL,
                            @V_DTCARDDEST, @C_COMENSSERV_QTCOM, @C_COMENSSERV_QTCLI, @C_COMENSSERV_QTFUN,
                            @C_COMENSSERV_QTDOA, 0, 0, 0, 0, 'N');
                     END;
                  END;
                  FETCH NEXT FROM C_CARDFILIAGREG INTO @C_CARDAGREG_CDFILIAL;
               END;
               CLOSE C_CARDFILIAGREG;
               DEALLOCATE C_CARDFILIAGREG;
            END
            ELSE BEGIN
               /* Se j existir cardpio, insere com o nmero antigo */
               SELECT
                  @V_NRCARDIAPMECENT = MAX(NRCARDIAPME),
                  @C_COMENSSERV_QTCOM_CENT = SUM(QTCOMESTCPME)
               FROM
                  CARDIAPME
               WHERE
                  (CDFILCENTPME = @P_CDFILIDEST ) AND
                  (NRCARDPME    = @P_NRCARDDEST ) AND
                  (CDSERVFILI   = @P_CDSERVDEST ) AND
                  (DTCARDIAPME  = @V_DTCARDDEST ) AND
                  (CDFILIAL     = CDFILCENTPME  );
            END; /* V_CONTCARDEST = 0 */

            IF (@C_COMENSSERV_QTCOM_CENT <> 0) AND (NOT(@C_COMENSSERV_QTCOM_CENT IS NULL)) BEGIN
            /* INSERT NA COMPCARD.... */
               SET @V_NOVOSEQ = @V_MAXNRSEQDEST;
               SET @V_NOVOORD = @V_MAXNRORDDEST;
               DECLARE C_PRATOSORIG CURSOR FOR
               SELECT
                  A.CDFILCENTPME, 
                  A.NRCARDPME,
                  A.NRSEQPRATCAR,
                  A.CDFILAUXPRAT,
                  A.CDPRATO,
                  A.VRPECONSCPME,
                  A.CDTIPOPRAT,
                  A.NRORDPRATCAR,
                  A.NMPRATO
               FROM
                  (SELECT
                      F.CDFILCENTPME,
                      C.NRCARDPME,
                      F.NRSEQCNFCPME NRSEQPRATCAR,
                      C.CDFILAUXPRAT,
                      ISNULL(C.CDPRATO,'') CDPRATO,
                      C.VRPECONSCPME,
                      F.CDTIPOPRAT,
                      F.NRORDCNFCPME NRORDPRATCAR,
                      P.NMPRATO
                   FROM
                      CONFCARDPME F,
  
                      CARDIAPME CD LEFT JOIN COMPCARDPME C
                         ON (C.CDFILCENTPME  = CD.CDFILCENTPME AND
                             C.NRCARDPME     = CD.NRCARDPME    AND
                             C.NRCARDIAPME   = CD.NRCARDIAPME     )

                      LEFT JOIN PRATO P     
                         ON (C.CDPRATO = P.CDPRATO           AND
                             C.CDFILAUXPRAT = P.CDFILAUXPRAT      )

                  WHERE
                     (CD.CDFILCENTPME    = @P_CDFILIORIG       ) AND
                     (CD.NRCARDPME       = @P_NRCARDORIG       ) AND
                     (CD.CDSERVFILI      = @P_CDSERVORIG       ) AND
                     (CD.CDFILCENTPME    = CD.CDFILIAL         ) AND
                     (CD.DTCARDIAPME     = @C_DATAS_DTORIGEM   ) AND
                     (CHARINDEX(RIGHT(REPLICATE('0', 3) + CONVERT(VARCHAR, C.NRSEQPRACPME), 3), @P_CONFIGORIG) <> 0) AND
                     (F.CDFILCENTPME     = CD.CDFILCENTPME     ) AND
                     (F.NRCARDPME        = CD.NRCARDPME        ) AND
                     (F.CDSERVFILI       = CD.CDSERVFILI       ) AND
                     (C.NRSEQPRACPME     = F.NRSEQCNFCPME      ) 
                  UNION 
                  SELECT 
                     F.CDFILCENTPME,
                     @P_NRCARDORIG NRCARDPME, 
                     F.NRSEQCNFCPME NRSEQPRATCAR,
                     'P' CDFILAUXPRAT, 
                     '' CDPRATO,
                     0 VRPECONSCPME, 
                     F.CDTIPOPRAT,
                     F.NRORDCNFCPME NRORDPRATCAR,
                     '' AS NMPRATO
                  FROM
                     CARDIAPME CD,
                     CONFCARDPME F
                  WHERE
                     (CD.CDFILCENTPME    = @P_CDFILIORIG       ) AND
                     (CD.NRCARDPME       = @P_NRCARDORIG       ) AND
                     (CD.CDSERVFILI      = @P_CDSERVORIG       ) AND
                     (CD.CDFILCENTPME    = CD.CDFILIAL         ) AND
                     (CD.DTCARDIAPME     = @C_DATAS_DTORIGEM   ) AND
                     (CHARINDEX(RIGHT(REPLICATE('0', 3) + CONVERT(VARCHAR, F.NRSEQCNFCPME), 3), @P_CONFIGORIG) <> 0) AND
                     (F.CDFILCENTPME     = CD.CDFILCENTPME     ) AND
                     (F.NRCARDPME        = CD.NRCARDPME        ) AND
                     (F.CDSERVFILI       = CD.CDSERVFILI       ) AND
                     (NOT EXISTS (SELECT
                                     F2.NRORDCNFCPME NRORDPRATCAR
                                  FROM
                                     CONFCARDPME F2,

                                     CARDIAPME CD2 LEFT JOIN COMPCARDPME C2
                                        ON (C2.CDFILCENTPME  = CD2.CDFILCENTPME  AND
                                            C2.NRCARDPME     = CD2.NRCARDPME     AND
                                            C2.NRCARDIAPME   = CD2.NRCARDIAPME       )

                                      LEFT JOIN PRATO P2     
                                         ON (P2.CDPRATO      = C2.CDPRATO     AND
                                             P2.CDFILAUXPRAT = C2.CDFILAUXPRAT       )

                                  WHERE
                                     (CD2.CDFILCENTPME    = @P_CDFILIORIG       ) AND
                                     (CD2.NRCARDPME       = @P_NRCARDORIG       ) AND
                                     (CD2.CDSERVFILI      = @P_CDSERVORIG       ) AND
                                     (CD2.CDFILCENTPME    = CD2.CDFILIAL        ) AND
                                     (CD2.DTCARDIAPME     = @C_DATAS_DTORIGEM   ) AND
                                     (CHARINDEX(RIGHT(REPLICATE('0', 3) + CONVERT(VARCHAR, F2.NRSEQCNFCPME), 3), @P_CONFIGORIG) <> 0) AND
                                     (F2.CDFILCENTPME     = CD2.CDFILCENTPME   ) AND
                                     (F2.NRCARDPME        = CD2.NRCARDPME      ) AND
                                     (F2.CDSERVFILI       = CD2.CDSERVFILI     ) AND
                                     (C2.NRSEQPRACPME     = F2.NRSEQCNFCPME    ) AND
                                     (F.NRORDCNFCPME      = F2.NRORDCNFCPME    ))
                 ))A
                 ORDER BY
                    A.NRSEQPRATCAR


               OPEN C_PRATOSORIG;
               FETCH NEXT FROM C_PRATOSORIG INTO @C_PRATOS_CDFILIAL,
                                                 @C_PRATOS_NRCARDPME,
                                                 @C_PRATOS_NRSEQPRATCAR,
                                                 @C_PRATOS_CDFILAUXPRAT,
                                                 @C_PRATOS_CDPRATO,
                                                 @C_PRATOS_VRPECONSCPME,
                                                 @C_PRATOS_CDTIPOPRAT,
                                                 @C_PRATOS_NRORDPRATCAR,
                                                 @C_PRATOS_NMPRATO;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_NOVOSEQ = @V_NOVOSEQ + 1;
                  SET @V_NOVOORD = @V_NOVOORD + 1;

                  IF @C_PRATOS_CDPRATO <> '' BEGIN
                     SET @V_CDFILAUXDEST = @C_PRATOS_CDFILAUXPRAT;
                     IF @C_PRATOS_CDFILAUXPRAT <> 'P' BEGIN
                        SET @V_CDFILAUXDEST = @P_CDFILIDEST;
                     END;

                     /* Verifica se o prato existe na filial destino */
                     SET @V_CONTPRAT = 1;
                     IF @P_CDFILIDEST <> @P_CDFILIORIG BEGIN
                        SET @V_CONTPRAT = 0;
                        SELECT
                           @V_CONTPRAT = COUNT(*)
                        FROM
                           PRATO
                        WHERE
                           (CDFILAUXPRAT = @V_CDFILAUXDEST   ) AND
                           (CDPRATO      = @C_PRATOS_CDPRATO ) AND
                           (TEKNISA.STRCOMP(NMPRATO, @C_PRATOS_NMPRATO, 0) = 0);
                     END;

                     SELECT
                        @V_IDUTRPADCA = MAX(IDUTRPADCA)
                     FROM
                        PARAMGERAL
                     WHERE
                        CDPARGERAL = '0001';

                     /* IDUTRPADCA = 'N' --> NO PERMITE RECEITA PADRO NO CARDPIO */
                     SET @V_CONTPRODRECE = 0;
                     IF @V_IDUTRPADCA = 'N' BEGIN
                        SELECT
                           @V_CONTPRODRECE = SUM(NUM)
                        FROM
                        (SELECT
                            NUM = COUNT(*)
                         FROM
                            RECETPCARD
                         WHERE
                            CDFILAUXPRAT = @V_CDFILAUXDEST  AND
                            CDPRATO = @C_PRATOS_CDPRATO AND
                            CDFILCENTPME =  @C_PRATOS_CDFILIAL AND
                            CDTIPOCARD = @P_CDTIPOCARD
                         UNION ALL
                         SELECT
                            NUM = COUNT(*)
                         FROM
                            RECEFILI
                         WHERE
                           (CDFILAUXPRAT = @V_CDFILAUXDEST   ) AND
                           (CDPRATO      = @C_PRATOS_CDPRATO) AND
                           (CDFILIAL     = @P_CDFILIDEST    )
                        UNION ALL
                        SELECT
                           NUM = COUNT(*)
                        FROM
                           RECESERV
                        WHERE
                           (CDFILAUXPRAT = @V_CDFILAUXDEST  ) AND
                           (CDPRATO      = @C_PRATOS_CDPRATO) AND
                           (CDFILIAL     = @P_CDFILIDEST    ) AND
                           (CDSERVFILI   = @P_CDSERVDEST    )
                        )A;
                     END
                     ELSE BEGIN
                        SELECT
                           @V_CONTPRODRECE = SUM(NUM)
                        FROM
                        (SELECT
                           NUM = COUNT(*)
                         FROM
                            RECEPADR
                         WHERE
                            (CDFILAUXPRAT = @V_CDFILAUXDEST  ) AND
                            (CDPRATO      = @C_PRATOS_CDPRATO)
                         UNION ALL
                         SELECT
                            NUM = COUNT(*)
                         FROM
                            RECETPCARD
                         WHERE
                            CDFILAUXPRAT = @V_CDFILAUXDEST  AND
                            CDPRATO = @C_PRATOS_CDPRATO AND
                            CDFILCENTPME =  @C_PRATOS_CDFILIAL AND
                            CDTIPOCARD = @P_CDTIPOCARD
                         UNION ALL
                         SELECT
                            NUM = COUNT(*)
                         FROM
                            RECEFILI
                         WHERE
                            (CDFILAUXPRAT = @V_CDFILAUXDEST  ) AND
                            (CDPRATO      = @C_PRATOS_CDPRATO) AND
                            (CDFILIAL     = @P_CDFILIDEST    )
                         UNION ALL
                         SELECT
                            NUM = COUNT(*)
                         FROM
                            RECESERV
                         WHERE
                            (CDFILAUXPRAT = @V_CDFILAUXDEST  ) AND
                            (CDPRATO      = @C_PRATOS_CDPRATO) AND
                            (CDFILIAL     = @P_CDFILIDEST    ) AND
                            (CDSERVFILI   = @P_CDSERVDEST    )
                        )A;
                     END;

                     IF (@V_CONTPRAT <> 0) AND (@V_CONTPRODRECE <> 0) BEGIN
                        /* ACRESCENTAR */
                        /* OBS.: Os tipos de prato sero includos ao final da tabela de configurao */

                        INSERT INTO COMPCARDPME
                           (CDFILCENTPME,
                            NRCARDPME,
                            NRCARDIAPME,
                            NRSEQPRACPME,
                            CDFILAUXPRAT,
                            CDPRATO,
                            VRPECONSCPME,
                            CDTIPOPRAT,
                            NRORDPRACPME)
                        VALUES
                           (@P_CDFILIDEST,
                            @P_NRCARDDEST,
                            @V_NRCARDIAPMECENT,
                            @V_NOVOSEQ,
                            @V_CDFILAUXDEST,
                            @C_PRATOS_CDPRATO,
                            @C_PRATOS_VRPECONSCPME,
                            @C_PRATOS_CDTIPOPRAT,
                            @V_NOVOORD);
                     END;
                  END;
                  FETCH NEXT FROM C_PRATOSORIG INTO @C_PRATOS_CDFILIAL,
                                                    @C_PRATOS_NRCARDPME,
                                                    @C_PRATOS_NRSEQPRATCAR,
                                                    @C_PRATOS_CDFILAUXPRAT,
                                                    @C_PRATOS_CDPRATO,
                                                    @C_PRATOS_VRPECONSCPME,
                                                    @C_PRATOS_CDTIPOPRAT,
                                                    @C_PRATOS_NRORDPRATCAR,
                                                    @C_PRATOS_NMPRATO;
               END; /* C_PRATOSORIG */
               CLOSE C_PRATOSORIG;
               DEALLOCATE C_PRATOSORIG;
            END;
            FETCH NEXT FROM C_CARDORIG INTO @C_CARD_CDFILCENTPME,
                                            @C_CARD_CDSERVFILI,
                                            @C_CARD_DTCARDIAPME,
                                            @C_CARD_NRCARDIAPME,
                                            @C_CARD_NRCARDPME,
                                            @C_CARD_QTCOMESTCPME,
                                            @C_CARD_QTCLIESTCPME,
                                            @C_CARD_QTFUNESTCPME,
                                            @C_CARD_QTDOAESTCPME;
         END; /* C_CARDORIG */
         CLOSE C_CARDORIG;
         DEALLOCATE C_CARDORIG;
      END; /* V_DTCARDDEST */
      SET @V_DTCARDDEST = @V_DTCARDDEST + 1;
      FETCH NEXT FROM C_DATAS INTO @C_DATAS_DTORIGEM;
   END; /* C_DATAS */
   CLOSE C_DATAS;
   DEALLOCATE C_DATAS;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'EXPORTA_CARDAPIOPME','6.45.041';
GO

